module.exports = {
  env: {
    browser: true,
    es2021: true,
    node: true,
  },
  extends: [
    'eslint:recommended', 'google',
  ],
  parserOptions: {
    ecmaVersion: 2021, // ecma2021
    sourceType: 'module',
  },
  rules: {
    'require-jsdoc': 'off',
    'no-constant-condition': ['error', {checkLoops: false}], /* while(true) is a common and useful idiom */
    'no-inner-declarations': 'off',

    /* Formatting annoyances: */
    'max-len': ['error', {code: 120, ignoreComments: true, ignoreTrailingComments: true}],
    'no-trailing-spaces': ['error', {skipBlankLines: true, ignoreComments: true}],
    'no-multiple-empty-lines': 'off',
    'padded-blocks': 'off',
    'one-var': 'off',
    'no-multi-spaces': 'off',
    'computed-property-spacing': 'off',

    'new-cap': 'off', /* Just causes problems with callbacks */

    'valid-jsdoc': 'off', /* Eslint can't parse closure/typescript complex types */

    /* Make into warnings - these are common when prototyping code: */
    'no-unused-vars': 'warn',
    'prefer-const': 'warn',
  },
};
